/***************************************************************************
 *   Copyright (C) 2009 by Xavier Lefage                                   *
 *   xavier.kwooty@gmail.com                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <KXmlGuiWindow>
#include <KUrl>
#include "utility.h"
using namespace UtilityNamespace;

class MyStatusBar;
class MyTreeView;
class CentralWidget;

class MainWindow : public KXmlGuiWindow

{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void openFileWithFileMode(KUrl, UtilityNamespace::OpenFileMode);

private:
    QString fileName;
    CentralWidget* centralWidget;
    MyStatusBar* statusBar;
    MyTreeView* treeView;

    void setupActions();
    bool queryClose() ;

signals:
    void aboutToShowSettingsSignal();
    void savePendingDownloadsSignal();

public slots:


private slots:
    void openFile();
    void showSettings();
    void quit();

};

#endif
